/**
 * Created by slashhuang on 16/7/17.
 * 执行打点
 */

'use strict';

exports.__esModule = true;
var logCore = function logCore(eventType) {
    return function () {
        //将方法重定向到jQuery的方法
        var container = this;
        //采用统一的jquery方式
        if (eventType == 'on') {
            $.fn.on.apply(container, logUtils.transArgs.apply(logUtils, arguments));
        } else {
            $.fn.on.apply(container, [eventType].concat(logUtils.transArgs.apply(logUtils, arguments)));
        }
    };
};

var logUtils = {
    /**
     * 修改回调函数，嵌入打点
     * @param callback
     * @return {Function}
     */
    transArgs: function transArgs() {
        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        var callback = args.pop(),
            _this = this,
            finalCallback = function finalCallback() {
            for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                args[_key2] = arguments[_key2];
            }

            if (typeof callback == 'function') {
                callback && callback.apply(this, args);
            }
            //如果设置了logger为false，则不进行logger
            if (!$(this).data('stopLog')) {
                _this.triggerLogger.apply(this, args);
            }
        };
        //如果最后一个参数不是函数，则还是塞回去
        if (typeof callback != 'function') {
            args.push(callback);
        }
        args.push(finalCallback);
        return args;
    },
    /**
     * 返回日志参数
     * @param args
     * @return {*}
     */

    /**
     * 打点模块
     */
    triggerLogger: function triggerLogger() {
        //获取打点参数
        var $this = $(this);
        var keyName = $this.data('logKey');
        var dealKey = $.fn.logger.logModule[keyName];
        var logArgs = {};
        if (typeof dealKey == 'function') {
            for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
                args[_key3] = arguments[_key3];
            }

            logArgs = dealKey.apply.apply(dealKey, [this].concat(args));
        } else if (typeof dealKey == 'object') {
            logArgs = dealKey;
        }
        //执行打点

        $.fn.logger.executor(logArgs);
    }
};
exports['default'] = logCore;
module.exports = exports['default'];